diff -ruN ../nakedmudv3.2.1/src/scripts/pymudsys.c src/scripts/pymudsys.c
--- ../nakedmudv3.2.1/src/scripts/pymudsys.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pymudsys.c	2006-12-24 22:15:56.000000000 -0500
@@ -14,11 +14,15 @@
 #include "../character.h"
 #include "../socket.h"
 #include "../save.h"
+#include "../handler.h"
+#include "../account.h"
 
 #include "pymudsys.h"
 #include "scripts.h"
 #include "pyplugs.h"
 #include "pychar.h"
+#include "pyaccount.h"
+#include "pysocket.h"
 
 
 
@@ -64,33 +68,284 @@
   return Py_BuildValue("i", 1);
 }
 
+PyObject *mudsys_create_account(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "A string name must be supplied.");
+    return NULL;
+  }
+
+  if(account_exists(name))
+    return Py_BuildValue("O", Py_None);
+  if(account_creating(name))
+    return Py_BuildValue("O", Py_None);
+  ACCOUNT_DATA *acct = newAccount();
+  accountSetName(acct, name);
+  return Py_BuildValue("O", accountGetPyFormBorrowed(acct));
+}
+
+PyObject *mudsys_create_player(PyObject *Self, PyObject *args) {
+  char *name = NULL;
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "A string name must be supplied.");
+    return NULL;
+  }
+
+  if(player_exists(name))
+    return Py_BuildValue("O", Py_None);
+  if(player_creating(name))
+    return Py_BuildValue("O", Py_None);
+  CHAR_DATA *ch = newChar();
+  charSetName(ch, name);
+
+  // give the character a unique id 
+  int next_char_uid = mudsettingGetInt("puid") + 1;
+  mudsettingSetInt("puid", next_char_uid);
+  charSetUID(ch, next_char_uid);
+      
+  // if it's the first player, give him all priviledges
+  if(charGetUID(ch) == 1)
+    bitSet(charGetUserGroups(ch),
+	   "admin, builder, scripter, player, playtester");
+
+  char_exist(ch);
+  return Py_BuildValue("O", charGetPyFormBorrowed(ch));
+}
+
+PyObject *mudsys_player_exists(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "A string name must be supplied.");
+    return NULL;
+  }
+  return Py_BuildValue("i", player_exists(name));
+}
+
+PyObject *mudsys_account_exists(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "A string name must be supplied.");
+    return NULL;
+  }
+  return Py_BuildValue("i", account_exists(name));
+}
+
+PyObject *mudsys_player_creating(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "A string name must be supplied.");
+    return NULL;
+  }
+  return Py_BuildValue("i", player_creating(name));
+}
+
+PyObject *mudsys_account_creating(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "A string name must be supplied.");
+    return NULL;
+  }
+  return Py_BuildValue("i", account_creating(name));
+}
+
+//
+// registers a player into the system
+PyObject *mudsys_do_register(PyObject *Self, PyObject *args) {
+  PyObject      *val = NULL;
+  CHAR_DATA      *ch = NULL;
+  ACCOUNT_DATA *acct = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &val)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "A char or account to be registered must be supplied.");
+    return NULL;
+  }
+
+  if(PyChar_Check(val)) {
+    if((ch = PyChar_AsChar(val)) == NULL) {
+      PyErr_Format(PyExc_StandardError,
+		   "Tried to register nonexistant player, %d.",
+		   PyChar_AsUid(val));
+      return NULL;
+    }
+    if(!charIsNPC(ch))
+      register_player(ch);
+  }
+  else if(PyAccount_Check(val)) {
+    if((acct = PyAccount_AsAccount(val)) == NULL) {
+      PyErr_Format(PyExc_StandardError,
+		   "Tried to register nonexistant account.");
+      return NULL;
+    }
+    register_account(acct);
+  }
+  else { 
+    PyErr_Format(PyExc_TypeError, 
+		 "Only players and accounts may be registered.");
+    return NULL;
+  }
+
+  return Py_BuildValue("i", 1);
+}
+
 //
 // saves a player to disk
 PyObject *mudsys_do_save(PyObject *self, PyObject *args) {
-  PyObject *pych = NULL;
-  CHAR_DATA  *ch = NULL;
+  PyObject      *val = NULL;
+  CHAR_DATA      *ch = NULL;
+  ACCOUNT_DATA *acct = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &val)) {
+    PyErr_Format(PyExc_TypeError, "A character or account must be supplied.");
+    return NULL;
+  }
 
-  if(!PyArg_ParseTuple(args, "O", &pych)) {
-    PyErr_Format(PyExc_TypeError, "A character to be saved must be supplied.");
+  if(PyChar_Check(val)) {
+    if( (ch = PyChar_AsChar(val)) == NULL) {
+      PyErr_Format(PyExc_StandardError,
+		   "Tried to save nonexistant character, %d.",
+		   PyChar_AsUid(val));
+      return NULL;
+    }
+    // only save registered characters
+    if(!player_exists(charGetName(ch)))
+      return Py_BuildValue("i", 0);
+    if(!charIsNPC(ch))
+      save_player(ch);
+  }
+  else if(PyAccount_Check(val)) {
+    if( (acct = PyAccount_AsAccount(val)) == NULL) {
+      PyErr_Format(PyExc_StandardError, "Tried to save nonexistant account.");
+      return NULL;
+    }
+    // only save registered players
+    if(!account_exists(accountGetName(acct)))
+      return Py_BuildValue("i", 0);
+    save_account(acct);
+  }
+  else {
+    PyErr_Format(PyExc_TypeError, "Only characters and accounts may be saved.");
+    return NULL;
+  }
+
+  return Py_BuildValue("i", 1);
+}
+
+//
+// attaches an account to a socket
+PyObject *mudsys_attach_account_socket(PyObject *self, PyObject *args) {
+  PyObject   *pyacct = NULL;
+  PyObject   *pysock = NULL;
+  ACCOUNT_DATA *acct = NULL;
+  SOCKET_DATA  *sock = NULL;
+
+  if(!PyArg_ParseTuple(args, "OO", &pyacct, &pysock)) {
+    PyErr_Format(PyExc_TypeError,"An account and socket to be attached must be supplied.");
+    return NULL;
+  }
+
+  if(!PyAccount_Check(pyacct)) {
+    PyErr_Format(PyExc_TypeError, "First argument must be an account.");
+    return NULL;
+  }
+  if(!PySocket_Check(pysock)) {
+    PyErr_Format(PyExc_TypeError, "Second argument must be a socket.");
+    return NULL;
+  }
+
+  if( (acct = PyAccount_AsAccount(pyacct)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to attach nonexistant account.");
+    return NULL;
+  }
+  if( (sock = PySocket_AsSocket(pysock)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to attach nonexistant socket, %d.",PySocket_AsUid(pysock));
+    return NULL;
+  }
+
+  // first, do any nessessary detaching for our old character and old socket
+  if(socketGetAccount(sock) != NULL && 
+     account_exists(accountGetName(socketGetAccount(sock))))
+    unreference_account(socketGetAccount(sock));
+  socketSetAccount(sock, acct);
+  if(account_exists(accountGetName(acct)))
+    reference_account(acct);
+  return Py_BuildValue("i", 1);
+}
+
+//
+// attaches a character to a socket
+PyObject *mudsys_attach_char_socket(PyObject *self, PyObject *args) {
+  PyObject    *pych = NULL;
+  PyObject  *pysock = NULL;
+  CHAR_DATA     *ch = NULL;
+  SOCKET_DATA *sock = NULL;
+
+  if(!PyArg_ParseTuple(args, "OO", &pych, &pysock)) {
+    PyErr_Format(PyExc_TypeError,"A character and socket to be attached must be supplied.");
     return NULL;
   }
 
   if(!PyChar_Check(pych)) {
-    PyErr_Format(PyExc_TypeError, "Only characters may be saved.");
+    PyErr_Format(PyExc_TypeError, "First argument must be a character.");
+    return NULL;
+  }
+  if(!PySocket_Check(pysock)) {
+    PyErr_Format(PyExc_TypeError, "Second argument must be a socket.");
     return NULL;
   }
 
   if( (ch = PyChar_AsChar(pych)) == NULL) {
     PyErr_Format(PyExc_StandardError,
-		 "Tried to save nonexistant character, %d.",PyChar_AsUid(pych));
+		 "Tried to attach nonexistant character, %d.",PyChar_AsUid(pych));
+    return NULL;
+  }
+  if( (sock = PySocket_AsSocket(pysock)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to attach nonexistant socket, %d.",PySocket_AsUid(pysock));
     return NULL;
   }
 
-  if(!charIsNPC(ch))
-    save_player(ch);
+  // first, do any nessessary detaching for our old character and old socket
+  if(socketGetChar(sock) != NULL)
+    charSetSocket(socketGetChar(sock), NULL);
+  if(charGetSocket(ch) != NULL)
+    socketSetChar(charGetSocket(ch), NULL);
+  charSetSocket(ch, sock);
+  socketSetChar(sock, ch);
   return Py_BuildValue("i", 1);
 }
 
+//
+// detaches a character from its socket
+PyObject *mudsys_detach_char_socket(PyObject *self, PyObject *args) {
+  PyObject    *pych = NULL;
+  CHAR_DATA     *ch = NULL;
+  SOCKET_DATA *sock = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &pych)) {
+    PyErr_Format(PyExc_TypeError,"A character to be detached must be supplied.");
+    return NULL;
+  }
+
+  if(!PyChar_Check(pych)) {
+    PyErr_Format(PyExc_TypeError, "Only characters may be detached.");
+    return NULL;
+  }
+
+  if( (ch = PyChar_AsChar(pych)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to detach nonexistant character, %d.",PyChar_AsUid(pych));
+    return NULL;
+  }
+
+  sock = charGetSocket(ch);
+  if(sock != NULL)
+    socketSetChar(sock, NULL);
+  charSetSocket(ch, NULL);
+  return Py_BuildValue("i", 1);
+}
 
 //
 // quits a character from the game
@@ -125,6 +380,73 @@
   return Py_BuildValue("i", 1);
 }
 
+//
+// loads an account from disk
+PyObject *mudsys_load_account(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "An account name must be supplied.");
+    return NULL;
+  }
+
+  // newPyAccount increases the reference count on the account. We can
+  // unreference it after we've created the Python wrapper for it
+  ACCOUNT_DATA *acct = get_account(name);
+  if(acct == NULL)
+    return Py_BuildValue("O", Py_None);
+  PyObject *retval = Py_BuildValue("O", accountGetPyFormBorrowed(acct));
+  unreference_account(acct);
+  return retval;
+}
+
+//
+// loads a character from disk
+PyObject *mudsys_load_char(PyObject *self, PyObject *args) {
+  char *name = NULL;
+  
+  if(!PyArg_ParseTuple(args, "s", &name)) {
+    PyErr_Format(PyExc_TypeError, "A character name must be supplied.");
+    return NULL;
+  }
+
+  CHAR_DATA *ch = get_player(name);
+  if(ch == NULL)
+    return Py_BuildValue("O", Py_None);
+
+  char_exist(ch);
+  return Py_BuildValue("O", charGetPyFormBorrowed(ch));
+}
+
+//
+// tries to put the player into the game
+PyObject *mudsys_try_enter_game(PyObject *self, PyObject *args) {
+  PyObject *pych = NULL;
+  CHAR_DATA  *ch = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &pych)) {
+    PyErr_Format(PyExc_TypeError,"A character to enter game must be supplied.");
+    return NULL;
+  }
+
+  if(!PyChar_Check(pych)) {
+    PyErr_Format(PyExc_TypeError, "Only characters may enter game.");
+    return NULL;
+  }
+
+  if((ch = PyChar_AsChar(pych)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried enter game with nonexistant character, %d.",
+		 PyChar_AsUid(pych));
+    return NULL;
+  }
+
+  // only enter game if we're not already in the game
+  if(listIn(mobile_list, ch))
+    return Py_BuildValue("i", 0);
+  else
+    return Py_BuildValue("i", try_enter_game(ch));
+}
 
 //
 // disconnects a character from its socket
@@ -158,6 +480,56 @@
   return Py_BuildValue("i", 1);
 }
 
+PyObject *mudsys_password_matches(PyObject *self, PyObject *args) {
+  PyObject   *pyacct = NULL;
+  char          *pwd = NULL;
+  ACCOUNT_DATA *acct = NULL;
+
+  if(!PyArg_ParseTuple(args, "Os", &pyacct, &pwd)) {
+    PyErr_Format(PyExc_TypeError, "an account and password must be supplied.");
+    return NULL;
+  }
+
+  if(!PyAccount_Check(pyacct)) {
+    PyErr_Format(PyExc_TypeError, "only accounts may have passwords checked.");
+    return NULL;
+  }
+
+  if( (acct = PyAccount_AsAccount(pyacct)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to check password for nonexistant account.");
+    return NULL;
+  }
+
+  return Py_BuildValue("i", compares(crypt(pwd, accountGetName(acct)), 
+				     accountGetPassword(acct)));
+}
+
+PyObject *mudsys_set_password(PyObject *self, PyObject *args) {
+  PyObject   *pyacct = NULL;
+  char          *pwd = NULL;
+  ACCOUNT_DATA *acct = NULL;
+
+  if(!PyArg_ParseTuple(args, "Os", &pyacct, &pwd)) {
+    PyErr_Format(PyExc_TypeError, "an account and password must be supplied.");
+    return NULL;
+  }
+
+  if(!PyAccount_Check(pyacct)) {
+    PyErr_Format(PyExc_TypeError, "only accounts may have passwords set.");
+    return NULL;
+  }
+
+  if( (acct = PyAccount_AsAccount(pyacct)) == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to set password for nonexistant account.");
+    return NULL;
+  }
+
+  accountSetPassword(acct, crypt(pwd, accountGetName(acct)));
+  return Py_BuildValue("i", 1);
+}
+
 
 //
 // add a new command to the mud, via a python script or module. Takes in a
@@ -191,7 +563,7 @@
   // add the command to the game
   add_py_cmd(name, sort_by, func, min_pos_num, max_pos_num,
 	     group, mob_ok, interrupts);
-  return Py_None;
+  return Py_BuildValue("O", Py_None);
 }
 
 
@@ -205,7 +577,55 @@
     return NULL;
   }
   remove_cmd(name);
-  return Py_None;
+  return Py_BuildValue("O", Py_None);
+}
+
+
+PyObject *mudsys_handle_cmd_input(PyObject *self, PyObject *args) {
+  PyObject  *pysock = NULL;
+  SOCKET_DATA *sock = NULL;
+  char         *cmd = NULL;
+
+  if(!PyArg_ParseTuple(args, "Os", &pysock, &cmd)) {
+    PyErr_Format(PyExc_TypeError, "A socket and command must be supplied.");
+    return NULL;
+  }
+
+  if(!PySocket_Check(pysock)) {
+    PyErr_Format(PyExc_TypeError, "A socket must be supplied.");
+    return NULL;
+  }
+
+  if( (sock = PySocket_AsSocket(pysock)) == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to run command for nonexistent socket.");
+    return NULL;
+  }
+
+  handle_cmd_input(sock, cmd);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mudsys_show_prompt(PyObject *self, PyObject *args) {
+  PyObject  *pysock = NULL;
+  SOCKET_DATA *sock = NULL;
+
+  if(!PyArg_ParseTuple(args, "O", &pysock)) {
+    PyErr_Format(PyExc_TypeError, "A socket must be supplied.");
+    return NULL;
+  }
+
+  if(!PySocket_Check(pysock)) {
+    PyErr_Format(PyExc_TypeError, "A socket must be supplied.");
+    return NULL;
+  }
+
+  if( (sock = PySocket_AsSocket(pysock)) == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to show prompt to nonexistent socket.");
+    return NULL;
+  }
+
+  show_prompt(sock);
+  return Py_BuildValue("i", 1);
 }
 
 
@@ -238,16 +658,54 @@
 		     "sets a system value on the mud.");
   PyMudSys_addMethod("sys_getval", mudsys_get_sys_val, METH_VARARGS,
 		     "returns a system value on the mud.");
+  PyMudSys_addMethod("player_exists", mudsys_player_exists, METH_VARARGS,
+		     "returns whether a player with the name exists.");
+  PyMudSys_addMethod("account_exists", mudsys_account_exists, METH_VARARGS,
+		     "returns whether an account with the name exists.");
+  PyMudSys_addMethod("player_creating", mudsys_player_creating, METH_VARARGS,
+		     "returns whether a player with the name is creating.");
+  PyMudSys_addMethod("account_creating", mudsys_account_creating, METH_VARARGS,
+		     "returns whether an account with the name is creating.");
+  PyMudSys_addMethod("do_register", mudsys_do_register, METH_VARARGS,
+		     "register a player to disk, and with an account.");
+  PyMudSys_addMethod("load_char", mudsys_load_char, METH_VARARGS,
+		     "load a characer from disk");
+  PyMudSys_addMethod("load_account", mudsys_load_account, METH_VARARGS,
+		     "load an account from disk");
+  PyMudSys_addMethod("try_enter_game", mudsys_try_enter_game, METH_VARARGS,
+		     "Tries to put the character into the game world");
   PyMudSys_addMethod("do_save", mudsys_do_save, METH_VARARGS,
 		     "save a character to disk");
   PyMudSys_addMethod("do_quit", mudsys_do_quit, METH_VARARGS,
 		     "quit a character from game");
+  PyMudSys_addMethod("attach_account_socket",mudsys_attach_account_socket, 
+		     METH_VARARGS, "attaches an account and socket.");
+  PyMudSys_addMethod("attach_char_socket", mudsys_attach_char_socket, 
+		     METH_VARARGS, "attaches a char and socket.");
+  PyMudSys_addMethod("detach_char_socket", mudsys_detach_char_socket,
+		     METH_VARARGS, "detachs a char from a socket.");
   PyMudSys_addMethod("do_disconnect", mudsys_do_disconnect, METH_VARARGS,
 		     "disconnects a character from its socket");
+  PyMudSys_addMethod("password_matches", mudsys_password_matches, METH_VARARGS,
+		     "returns whether or not the password matches the account's"
+		     " password.");
+  PyMudSys_addMethod("set_password", mudsys_set_password, METH_VARARGS,
+		     "sets an account's password.");
   PyMudSys_addMethod("add_cmd", mudsys_add_cmd, METH_VARARGS,
 		     "Add a new command to the game.");
   PyMudSys_addMethod("remove_cmd", mudsys_remove_cmd, METH_VARARGS,
 		     "Removes a command from the game.");
+  PyMudSys_addMethod("handle_cmd_input", mudsys_handle_cmd_input, METH_VARARGS,
+		     "the default input handler for character commands.");
+  PyMudSys_addMethod("show_prompt", mudsys_show_prompt, METH_VARARGS,
+		     "the default character prompt. Can be replaced in Python "
+		     "by assigning a new prompt to the same named variable.");
+  PyMudSys_addMethod("create_account", mudsys_create_account, METH_VARARGS,
+		     "creates a new account by name. Must be registered "
+		     "after fully created.");
+  PyMudSys_addMethod("create_player", mudsys_create_player, METH_VARARGS,
+		     "creates a new player by name. Must be registered "
+		     "after fully created.");
 
   Py_InitModule3("mudsys", makePyMethods(pymudsys_methods),
 		 "The mudsys module, for all MUD system utils.");
diff -ruN ../nakedmudv3.2.1/src/scripts/pyobj.c src/scripts/pyobj.c
--- ../nakedmudv3.2.1/src/scripts/pyobj.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pyobj.c	2006-12-24 22:15:56.000000000 -0500
@@ -26,6 +26,7 @@
 #include "pychar.h"
 #include "pyroom.h"
 #include "pyobj.h"
+#include "pyauxiliary.h"
 
 
 
@@ -210,7 +211,7 @@
   if(obj == NULL)
     return NULL;
   if(objGetCarrier(obj) == NULL)
-    return Py_None;
+    return Py_BuildValue("O", Py_None);
   return Py_BuildValue("O", charGetPyFormBorrowed(objGetCarrier(obj)));
 }
 
@@ -219,7 +220,7 @@
   if(obj == NULL)
     return NULL;
   if(objGetRoom(obj) == NULL)
-    return Py_None;
+    return Py_BuildValue("O", Py_None);
   return Py_BuildValue("O", roomGetPyFormBorrowed(objGetRoom(obj)));
 }
 
@@ -228,7 +229,7 @@
   if(obj == NULL)
     return NULL;
   if(objGetContainer(obj) == NULL)
-    return Py_None;
+    return Py_BuildValue("O", Py_None);
   return Py_BuildValue("O", objGetPyFormBorrowed(objGetContainer(obj)));
 }
 
@@ -657,6 +658,41 @@
   }
 }
 
+//
+// returns the specified piece of auxiliary data from the object
+// if it is a piece of python auxiliary data.
+PyObject *PyObj_get_auxiliary(PyObj *self, PyObject *args) {
+  char *keyword = NULL;
+  if(!PyArg_ParseTuple(args, "s", &keyword)) {
+    PyErr_Format(PyExc_TypeError,
+		 "getAuxiliary() must be supplied with the name that the "
+		 "auxiliary data was installed under!");
+    return NULL;
+  }
+
+  // make sure we exist
+  OBJ_DATA *obj = PyObj_AsObj((PyObject *)self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to get auxiliary data for a nonexistant object.");
+    return NULL;
+  }
+
+  // make sure the auxiliary data exists
+  if(!pyAuxiliaryDataExists(keyword)) {
+    PyErr_Format(PyExc_StandardError,
+		 "No auxiliary data named '%s' exists!", keyword);
+    return NULL;
+  }
+
+  PyObject *data = objGetAuxiliaryData(obj, keyword);
+  if(data == NULL)
+    data = Py_None;
+  PyObject *retval = Py_BuildValue("O", data);
+  //  Py_DECREF(data);
+  return retval;
+}
+
 
 
 //*****************************************************************************
@@ -1054,6 +1090,8 @@
 		    "the object will become of the specified type");
     PyObj_addMethod("edesc", PyObj_edesc, METH_VARARGS,
 		    "adds an extra description to the object.");
+    PyObj_addMethod("getAuxiliary", PyObj_get_auxiliary, METH_VARARGS,
+		    "get's the specified piece of aux data from the obj");
 
     makePyType(&PyObj_Type, pyobj_getsetters, pyobj_methods);
     deleteListWith(pyobj_getsetters, free); pyobj_getsetters = NULL;
diff -ruN ../nakedmudv3.2.1/src/scripts/pyplugs.c src/scripts/pyplugs.c
--- ../nakedmudv3.2.1/src/scripts/pyplugs.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pyplugs.c	2006-12-24 22:15:56.000000000 -0500
@@ -170,10 +170,20 @@
       log_string("loading python module, %s", mname);
     // oops... something went wrong. Let's get the traceback
     else {
+      // we now abandon bootup if we fail to load a Python module, because it
+      // can have potentially dangerous affects on the loading of other modules
+      // Thanks to Thirsteh for pointing this out.
+      BUFFER *buf = newBuffer(1);
       char *tb = getPythonTraceback();
-      log_string("Error loading module, %s:\r\n%s\r\n",
-		 mname, tb);
+      bprintf(buf, "Error loading module, %s:\r\n%s\r\n"
+	           "Bootup aborted. MUD shutting down.", mname, tb);
+      log_string(bufferString(buf));
+      printf("%s", bufferString(buf));
+      
+      deleteBuffer(buf);
       free(tb);
+      closedir(dir);
+      exit(1);
     }
   }
   closedir(dir);
diff -ruN ../nakedmudv3.2.1/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv3.2.1/src/scripts/pyroom.c	2006-07-09 17:29:07.000000000 -0400
+++ src/scripts/pyroom.c	2006-12-24 22:15:56.000000000 -0500
@@ -29,6 +29,7 @@
 #include "pyexit.h"
 #include "pyroom.h"
 #include "pymud.h"
+#include "pyauxiliary.h"
 
 
 
@@ -364,7 +365,7 @@
     return retval;
   }
   else
-    return Py_None;
+    return Py_BuildValue("O", Py_None);
 }
 
 
@@ -610,7 +611,7 @@
   nearMapPut(roomGetCmdTable(room), name, sort_by,
 	     newPyCmd(name, func, POS_STANDING, POS_FLYING,
 		      group, TRUE, TRUE));
-  return Py_None;
+  return Py_BuildValue("O", Py_None);
 }
 
 //
@@ -636,6 +637,42 @@
   }
 }
 
+//
+// returns the specified piece of auxiliary data from the room
+// if it is a piece of python auxiliary data.
+PyObject *PyRoom_get_auxiliary(PyRoom *self, PyObject *args) {
+  char *keyword = NULL;
+  if(!PyArg_ParseTuple(args, "s", &keyword)) {
+    PyErr_Format(PyExc_TypeError,
+		 "getAuxiliary() must be supplied with the name that the "
+		 "auxiliary data was installed under!");
+    return NULL;
+  }
+
+  // make sure we exist
+  ROOM_DATA *room = PyRoom_AsRoom((PyObject *)self);
+  if(room == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried to get auxiliary data for a nonexistant room.");
+    return NULL;
+  }
+
+  // make sure the auxiliary data exists
+  if(!pyAuxiliaryDataExists(keyword)) {
+    PyErr_Format(PyExc_StandardError,
+		 "No auxiliary data named '%s' exists!", keyword);
+    return NULL;
+  }
+
+  PyObject *data = roomGetAuxiliaryData(room, keyword);
+  if(data == NULL)
+    data = Py_None;
+  PyObject *retval = Py_BuildValue("O", data);
+  //  Py_DECREF(data);
+  return retval;
+}
+
+
 
 
 //*****************************************************************************
@@ -768,6 +805,8 @@
 		     "adds a command to the room.");
     PyRoom_addMethod("isinstance", PyRoom_isinstance, METH_VARARGS,
 		     "returns whether or not the room inherits from the proto");
+    PyRoom_addMethod("getAuxiliary", PyRoom_get_auxiliary, METH_VARARGS,
+		     "get's the specified piece of aux data from the room");
 
     // add in all the getsetters and methods
     makePyType(&PyRoom_Type, pyroom_getsetters, pyroom_methods);
